#!/bin/bash


input_sparql_query_file=${1:-countries-in-esc-by-year.sparql}
output_ext=${2:-json}

output_file_root=${input_sparql_query_file%.*}

case "$output_ext" in
    "json" ) output_format="application/sparql-results+json"
    ;;

   "html" )  output_format="text/html"
    ;;

   "csv" )  output_format="text/csv"
    ;;
esac
	
output_result_file="$output_file_root.$output_ext"


source ./_lod_utils.bash

sparql_url="https://dbpedia.demo.openlinksw.com/sparql/"
# sparql_url="https://dbpedia.org/sparql"

graph_arg="default-graph-uri=http%3A%2F%2Fdbpedia.org"

#query_arg_safe='query=SELECT+%3Fcountries_in_esc_by_year+%3Fcountry_in_year+%3Fyear+%3Fcountry+%3Fentrant+%3Fsong%0D%0AWHERE+{%0D%0A+%3Fcountries_in_esc_by_year+skos%3Abroader+dbc%3ACountries_in_the_Eurovision_Song_Contest_by_year.%0D%0A%0D%0A+%3Fcountry_in_year+dct%3Asubject+%3Fcountries_in_esc_by_year.%0D%0A+bind(+REPLACE(str(%3Fcountry_in_year)%2C+".*(\\d{4})"%2C+"%241")+as+%3Fyear).%0D%0A+++FILTER+(+xsd%3Ainteger(%3Fyear)+<+2020).%0D%0A%0D%0A+%3Fcountry_in_year+dbp%3Acountry+%3Fcountry.%0D%0A+%3Fcountry_in_year+dbp%3Aentrant+%3Fentrant.%0D%0A%0D%0A+%3Fcountry_in_year+dbp%3Asong+%3Fsong.%0D%0A%23+%3Fsong+rdfs%3Alabel+%3Fsong_label%0D%0A%23+++FILTER+(lang(%3Fsong_label)+%3D+"en").%0D%0A%0D%0A%0D%0A}%0D%0AORDER+BY+DESC(%3Fcountries_in_esc_by_year)'
#echo "query arg safe ="
#echo $query_arg_safe


sparql_query=`cat "$input_sparql_query_file"`
query_arg_safe="query="$( rawurlencode "$sparql_query" )

output_format_arg_safe="format="$( rawurlencode "$output_format" )

additional_args="$output_format_arg_safe&timeout=30000&signal_void=on&signal_unconnected=on"


wget --no-check-certificate -O "$output_result_file" "$sparql_url?$graph_arg&$query_arg_safe&$additional_args"


